package aPRENDIZAJE;

/*
 * Copyright (c) 1995 - 2008 Sun Microsystems, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   - Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *   - Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *   - Neither the name of Sun Microsystems nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */ 

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class Explorador extends JPanel
                             implements ActionListener {
	private static final long serialVersionUID = 1L;
	
    JButton openButton, /*saveButton,*/ readButton;
    JTextFieldTabulador separ;
    JTextField num_lin_oe, num_lin_uni, num_lin_fec; 
    JTextField log;
    JLabel lsepar, loe, luni, lfec;
    JFileChooser fc;
    File file;

    public Explorador() {
        super(new BorderLayout());

        //crear campos de entrada:
        separ = new JTextFieldTabulador(1);
        separ.setFocusTraversalKeysEnabled(false);     

//        separ.setSize(1,1);
//        System.out.println(separ.getSize());
//        separ.setMaximumSize(separ.getSize());
//        separ.setEditable(true);
        //separ.addActionListener(this);

        //separ.setPreferredSize(getSize());
        //separ.setToolTipText(getToolTipText());
        num_lin_oe = new JTextField(3);
//        num_lin_oe.setPreferredSize(getSize());
        //TODO moverse por texto de una textArea de tamao fijo
        num_lin_uni = new JTextField(3);
//        num_lin_uni.setPreferredSize(getSize());
        num_lin_fec = new JTextField(3);
//        num_lin_fec.setPreferredSize(getSize());
        	
        //crear etiquetas:
        lsepar = new JLabel("Separador");
        loe = new JLabel("Linea Obj. Est");
        luni = new JLabel("Linea Uds");
        lfec = new JLabel("Linea Fechas");

        
        //For layout purposes, put the textAreas in a separate panel
        JPanel textAreasPanel = new JPanel(); //use FlowLayout
        textAreasPanel.add(lsepar);
        textAreasPanel.add(separ);
        textAreasPanel.add(loe);
        textAreasPanel.add(num_lin_oe);
        textAreasPanel.add(luni);
        textAreasPanel.add(num_lin_uni);
        textAreasPanel.add(lfec);
        textAreasPanel.add(num_lin_fec);
        
        //Create the log first, because the action listeners
        //need to refer to it.
//        log = new JTextArea(5,20);
//        log.setMargin(new Insets(5,5,5,5));
//        log.setEditable(false);
//        JScrollPane logScrollPane = new JScrollPane(log);
        log = new JTextField(30);
        //log.setPreferredSize(getSize());
        
        //Create a file chooser
        fc = new JFileChooser();

        //Uncomment one of the following lines to try a different
        //file selection mode.  The first allows just directories
        //to be selected (and, at least in the Java look and feel,
        //shown).  The second allows both files and directories
        //to be selected.  If you leave these lines commented out,
        //then the default mode (FILES_ONLY) will be used.
        //
        //fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        //fc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);

        //Create the open button.  We use the image from the JLF
        //Graphics Repository (but we extracted it from the jar).
//        openButton = new JButton("Open a File...",
//                                 createImageIcon("images/Open16.gif"));
        openButton = new JButton("Abrir Archivo...");
        openButton.addActionListener(this);

        //Create the save button.  We use the image from the JLF
        //Graphics Repository (but we extracted it from the jar).
//        saveButton = new JButton("Save a File...",
//                                 createImageIcon("images/Save16.gif"));
//        saveButton = new JButton("Save a File...");
//        saveButton.addActionListener(this);

        //For layout purposes, put the buttons in a separate panel
        JPanel buttonPanel = new JPanel(); //use FlowLayout
        buttonPanel.add(openButton);
//        buttonPanel.add(saveButton);
        
        //For layout purposes, put the buttons in a separate panel
        readButton = new JButton("Leer Archivo");
        readButton.addActionListener(this);
        
        JPanel readPanel = new JPanel(); //use FlowLayout
        //readPanel.add(archivo);
        readPanel.add(log);
        readPanel.add(readButton);
        
        JPanel todo = new JPanel();
        
        //Add the buttons and the log to this panel.
        todo.add(buttonPanel/*, BorderLayout.PAGE_START*/);
        //add(logScrollPane, BorderLayout.CENTER);
        todo.add(textAreasPanel/*, BorderLayout.CENTER*/);
        todo.add(readPanel/*, BorderLayout.PAGE_END*/);
        
        //TODO Drag&Drop
        add(todo);
        
    }

    public void actionPerformed(ActionEvent e) {

        //Handle open button action.
        if (e.getSource() == openButton) {
            int returnVal = fc.showOpenDialog(Explorador.this);

            if (returnVal == JFileChooser.APPROVE_OPTION) {
                file = fc.getSelectedFile();
                //This is where a real application would open the file.
//                archivo = new JLabel(file.getName());
                log.setText(file.getAbsolutePath());
                //log.updateUI();
                //log.append("Opening: " + file.getName() + "." + newline);
            } else {
            	//archivo = new JLabel("Open command cancelled by user.");
            	log.setText("Open command cancelled by user.");
                //log.append("Open command cancelled by user." + newline);
            }
            //log.setCaretPosition(log.getDocument().getLength());

        //Handle save button action.
/*        } else if (e.getSource() == saveButton) {
            int returnVal = fc.showSaveDialog(Explorador.this);
            if (returnVal == JFileChooser.APPROVE_OPTION) {
                file = fc.getSelectedFile();
                //This is where a real application would save the file.
                //log.append("Saving: " + file.getName() + "." + newline);
            } else {
                //log.append("Save command cancelled by user." + newline);
            }
            //log.setCaretPosition(log.getDocument().getLength());
          
*/
        } else if (e.getSource() == readButton) {
            char carsep = separ.getText().charAt(0);
            FicheroDatos fd = new FicheroDatos(file, carsep);
            try {
            	//TODO mostrar mensaje de error cuando no se dejen campos en blanco
				fd.leerFicheroDatos(log.getText(), carsep,Integer.parseInt(num_lin_oe.getText()),
						Integer.parseInt(num_lin_uni.getText()),Integer.parseInt(num_lin_fec.getText()));
			} catch (NumberFormatException e1) {
				e1.printStackTrace();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
			//System.out.println("hay tabulador?"  + "Aqui no hay");
            //System.out.println("hay tabulador?" + carsep + "SIIIII");
        }
    }
    
    /** Returns an ImageIcon, or null if the path was invalid. */
    protected static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = Explorador.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Couldn't find file: " + path);
            return null;
        }
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event dispatch thread.
     */
    public static void createAndShowGUI() {
        //Create and set up the window.
        JFrame frame = new JFrame("Explorador");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Add content to the window.
        frame.add(new Explorador());

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }
    
    

/*    public static void main(String[] args) {
        //Schedule a job for the event dispatch thread:
        //creating and showing this application's GUI.
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                //Turn off metal's use of bold fonts
                UIManager.put("swing.boldMetal", Boolean.FALSE); 
                createAndShowGUI();
            }
        });
    }
*/

}
